/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package com.samitaphuyal.monstermayhnem;

import com.samitaphuyal.monstermayhnem.model.Monster;
import com.samitaphuyal.monstermayhnem.model.Player;
import enums.typeEnums;
import java.awt.Toolkit;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Acer
 */
public class CombatSetup extends javax.swing.JFrame {

    DefaultTableModel model = new DefaultTableModel();
    int i = 1;
    int idCounter = 0;
    List<Monster> monsterList = new ArrayList<>();
    List<Player> playerLists = new ArrayList<>();
    List<Monster> selectedMonsterList = new ArrayList<>();

    public CombatSetup(List<Player> playerList,int id) {
        initComponents();
        idCounter = id;
        playerLists.addAll(playerList);
        fillComboBox();
        txtMonsters.setSelectedItem(0);
    }
    
    public void fillComboBox(){
        Monster monster1 = new Monster();
        monster1.setName("Harley Quinn - Samita");
        monster1.setPower(60);
        monster1.setLife(250);
        monster1.setHealth(monster1.getLife());
        monster1.setSpeed(2);
        monster1.setTypeOrWeapon("Fire");
        monster1.setPlayerOrMonster(typeEnums.MONSTER.getKey());
        
        
        Monster monster2 = new Monster();
        monster2.setName("Sasquatch");
        monster2.setPower(30);
        monster2.setLife(150);
        monster2.setHealth(monster2.getLife());
        monster2.setSpeed(1);
        monster2.setTypeOrWeapon("Ice");
        monster2.setPlayerOrMonster(typeEnums.MONSTER.getKey());
        
        Monster monster3 = new Monster();
        monster3.setName("Windigo");
        monster3.setPower(40);
        monster3.setLife(200);
        monster3.setHealth(monster3.getLife());
        monster3.setSpeed(3);
        monster3.setTypeOrWeapon("Water");
        monster3.setPlayerOrMonster(typeEnums.MONSTER.getKey());
        
        Monster monster4 = new Monster();
        monster4.setName("Tommy-knocker");
        monster4.setPower(50);
        monster4.setLife(100);
        monster4.setHealth(monster4.getLife());
        monster4.setSpeed(2);
        monster4.setTypeOrWeapon("Ice");
        monster4.setPlayerOrMonster(typeEnums.MONSTER.getKey());
        
        Monster monster5 = new Monster();
        monster5.setName("Snallygaster");
        monster5.setPower(20);
        monster5.setLife(180);
        monster5.setHealth(monster5.getLife());
        monster5.setSpeed(1);
        monster5.setTypeOrWeapon("Water");
        monster5.setPlayerOrMonster(typeEnums.MONSTER.getKey());
        
        monsterList.add(monster1);
        monsterList.add(monster2);
        monsterList.add(monster3);
        monsterList.add(monster4);
        monsterList.add(monster5);
        
        for(int i=0;i<monsterList.size();i++){
            String monsterName = monsterList.get(i).getName();
            txtMonsters.addItem(monsterName);
        }
    }
    
    public CombatSetup() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        txtMonsters = new javax.swing.JComboBox<>();
        selectButton = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        startCombat = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("MonsterMayhnem - Setup Combat");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));

        jLabel1.setFont(new java.awt.Font("Yu Gothic", 1, 24)); // NOI18N
        jLabel1.setText("Setup Combat");

        jLabel6.setText("Monster");

        txtMonsters.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtMonstersActionPerformed(evt);
            }
        });

        selectButton.setText("Select Monster");
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(selectButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(txtMonsters, 0, 129, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(48, 48, 48)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(txtMonsters, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 115, Short.MAX_VALUE)
                .addComponent(selectButton)
                .addGap(97, 97, 97))
        );

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Monster Id", "Name", "Power", "Life", "Speed", "Type"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane4.setViewportView(jTable1);

        startCombat.setText("Start Combat");
        startCombat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startCombatActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 601, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(startCombat, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel1)
                .addGap(324, 324, 324))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(28, 28, 28)
                .addComponent(startCombat, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(31, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void startCombatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startCombatActionPerformed
        if(selectedMonsterList.isEmpty()){
            JOptionPane.showMessageDialog(this,"Please add atleast one monster.");
        }else{
        close();
        CombatUI combatUi = new CombatUI(playerLists,selectedMonsterList);
        combatUi.setVisible(true);
        }
    }//GEN-LAST:event_startCombatActionPerformed

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonActionPerformed
            String monsterName = txtMonsters.getSelectedItem().toString();
            Monster monster = findMonsterFromName(monsterName);
            selectedMonsterList.add(monster);
            model = (DefaultTableModel) jTable1.getModel();
                     model.addRow(new Object[]{
                      i,monster.getName(),monster.getPower(),monster.getLife(),monster.getSpeed(),monster.getTypeOrWeapon()
                     });
             JOptionPane.showMessageDialog(this,"Monster : "+monster.getName()+" added.");
             i++;
    }//GEN-LAST:event_selectButtonActionPerformed

    public Monster findMonsterFromName(String name){
        Monster monster = new Monster();
        for(int i=0;i<monsterList.size();i++){
            if(monsterList.get(i).getName().equals(name)){
               monster.setId(idCounter);
               monster.setName(monsterList.get(i).getName());
               monster.setLife(monsterList.get(i).getLife());
               monster.setPower(monsterList.get(i).getPower());
               monster.setSpeed(monsterList.get(i).getSpeed());
               monster.setTypeOrWeapon(monsterList.get(i).getTypeOrWeapon());
               monster.setHealth(monsterList.get(i).getHealth());
               monster.setPlayerOrMonster(monsterList.get(i).getPlayerOrMonster());
               monsterList.remove(i);
               refreshList();
            }
        }
        idCounter++;
        return monster;
    }
    
     public void refreshList(){
        txtMonsters.removeAllItems();
        for(int i=0;i<monsterList.size();i++){
            String monsterName = monsterList.get(i).getName();
            txtMonsters.addItem(monsterName);
        }
    }
    
    private void txtMonstersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtMonstersActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtMonstersActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CombatSetup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CombatSetup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CombatSetup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CombatSetup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CombatSetup().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTable jTable1;
    private javax.swing.JButton selectButton;
    private javax.swing.JButton startCombat;
    private javax.swing.JComboBox<String> txtMonsters;
    // End of variables declaration//GEN-END:variables

    private void close() {
         WindowEvent closeWindow = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
        Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(closeWindow);
    }
}
